/*
 * OpenFairDB API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.9.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.AvgRatings;
import org.openapitools.client.model.ReviewStatus;

/**
 * The compact view of an entry as returned in search results.
 */
@ApiModel(description = "The compact view of an entry as returned in search results.")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-12-19T15:07:54.107442+01:00[Europe/Rome]")
public class SearchEntry {
  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private String id;

  public static final String SERIALIZED_NAME_STATUS = "status";
  @SerializedName(SERIALIZED_NAME_STATUS)
  private ReviewStatus status;

  public static final String SERIALIZED_NAME_LAT = "lat";
  @SerializedName(SERIALIZED_NAME_LAT)
  private Double lat;

  public static final String SERIALIZED_NAME_LNG = "lng";
  @SerializedName(SERIALIZED_NAME_LNG)
  private Double lng;

  public static final String SERIALIZED_NAME_TITLE = "title";
  @SerializedName(SERIALIZED_NAME_TITLE)
  private String title;

  public static final String SERIALIZED_NAME_DESCRIPTION = "description";
  @SerializedName(SERIALIZED_NAME_DESCRIPTION)
  private String description;

  public static final String SERIALIZED_NAME_CATEGORIES = "categories";
  @SerializedName(SERIALIZED_NAME_CATEGORIES)
  private List<String> categories = null;

  public static final String SERIALIZED_NAME_TAGS = "tags";
  @SerializedName(SERIALIZED_NAME_TAGS)
  private List<String> tags = null;

  public static final String SERIALIZED_NAME_RATINGS = "ratings";
  @SerializedName(SERIALIZED_NAME_RATINGS)
  private AvgRatings ratings;


  public SearchEntry id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * Identifier of a resource 
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "7cee99c287094a94acbdcf29ffff2e85", value = "Identifier of a resource ")

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public SearchEntry status(ReviewStatus status) {
    
    this.status = status;
    return this;
  }

   /**
   * Get status
   * @return status
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public ReviewStatus getStatus() {
    return status;
  }


  public void setStatus(ReviewStatus status) {
    this.status = status;
  }


  public SearchEntry lat(Double lat) {
    
    this.lat = lat;
    return this;
  }

   /**
   * Geographic latitude (in degrees)
   * minimum: -90.0
   * maximum: 90.0
   * @return lat
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "37.2", value = "Geographic latitude (in degrees)")

  public Double getLat() {
    return lat;
  }


  public void setLat(Double lat) {
    this.lat = lat;
  }


  public SearchEntry lng(Double lng) {
    
    this.lng = lng;
    return this;
  }

   /**
   * Geographic longitude (in degrees)
   * minimum: -180.0
   * maximum: 180.0
   * @return lng
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "120.7", value = "Geographic longitude (in degrees)")

  public Double getLng() {
    return lng;
  }


  public void setLng(Double lng) {
    this.lng = lng;
  }


  public SearchEntry title(String title) {
    
    this.title = title;
    return this;
  }

   /**
   * Get title
   * @return title
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getTitle() {
    return title;
  }


  public void setTitle(String title) {
    this.title = title;
  }


  public SearchEntry description(String description) {
    
    this.description = description;
    return this;
  }

   /**
   * Get description
   * @return description
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public String getDescription() {
    return description;
  }


  public void setDescription(String description) {
    this.description = description;
  }


  public SearchEntry categories(List<String> categories) {
    
    this.categories = categories;
    return this;
  }

  public SearchEntry addCategoriesItem(String categoriesItem) {
    if (this.categories == null) {
      this.categories = new ArrayList<String>();
    }
    this.categories.add(categoriesItem);
    return this;
  }

   /**
   * Get categories
   * @return categories
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public List<String> getCategories() {
    return categories;
  }


  public void setCategories(List<String> categories) {
    this.categories = categories;
  }


  public SearchEntry tags(List<String> tags) {
    
    this.tags = tags;
    return this;
  }

  public SearchEntry addTagsItem(String tagsItem) {
    if (this.tags == null) {
      this.tags = new ArrayList<String>();
    }
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * Get tags
   * @return tags
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "[\"organic\",\"non-profit\"]", value = "")

  public List<String> getTags() {
    return tags;
  }


  public void setTags(List<String> tags) {
    this.tags = tags;
  }


  public SearchEntry ratings(AvgRatings ratings) {
    
    this.ratings = ratings;
    return this;
  }

   /**
   * Get ratings
   * @return ratings
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public AvgRatings getRatings() {
    return ratings;
  }


  public void setRatings(AvgRatings ratings) {
    this.ratings = ratings;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SearchEntry searchEntry = (SearchEntry) o;
    return Objects.equals(this.id, searchEntry.id) &&
        Objects.equals(this.status, searchEntry.status) &&
        Objects.equals(this.lat, searchEntry.lat) &&
        Objects.equals(this.lng, searchEntry.lng) &&
        Objects.equals(this.title, searchEntry.title) &&
        Objects.equals(this.description, searchEntry.description) &&
        Objects.equals(this.categories, searchEntry.categories) &&
        Objects.equals(this.tags, searchEntry.tags) &&
        Objects.equals(this.ratings, searchEntry.ratings);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, status, lat, lng, title, description, categories, tags, ratings);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SearchEntry {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    lat: ").append(toIndentedString(lat)).append("\n");
    sb.append("    lng: ").append(toIndentedString(lng)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    categories: ").append(toIndentedString(categories)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    ratings: ").append(toIndentedString(ratings)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

